//
// Created by cr on 24.08.22.
//

#ifndef FWI_FWIRHSASSEMBLERLINEARIZED_HPP
#define FWI_FWIRHSASSEMBLERLINEARIZED_HPP

#include "m++.hpp"
#include "FWIAbstractInterfaceDGTSVA.hpp"
#include "DGAcousticElement.hpp"
#include "DGVAcousticRHSAssembler.hpp"
#include "FWILinearizedAssembler.hpp"

class DGVAcousticRHSAssemblerLinearized : public DGVAcousticRHSAssembler {
    const Vectors &U_m;
    std::unique_ptr<PMLWaveVectorFWI> PMLVec;
    std::unique_ptr<Matrix> A;
    std::unique_ptr<Matrix> B;
    mutable int step = 0;
    mutable bool increaseStep = false;
    PMLHandler *PMLH;
    std::unique_ptr<Vector> VecTmp;

public:
    int rkorder = -1;

    DGVAcousticRHSAssemblerLinearized(const Vectors &U, std::shared_ptr<WaveProblemDGTSVA> problem_fwd_,
                                      const std::unordered_map<Point, DGAcousticElement *> &eleCache_,
                                      const Vector &materialPoint_, const Vector &m_test, double dt, bool discrete,
                                      PMLHandler *handler);

    void RHS(double t, Vector &b) const override;

    void Initialize(Vector &) const override {}

    ~DGVAcousticRHSAssemblerLinearized() = default;

};

#endif //FWI_FWIRHSASSEMBLERLINEARIZED_HPP
