// $Header: /public/M++/Fruitfly/src/Main.C,v 1.29 2011-09-30 16:08:44 wieners Exp $
//#include "m++.hpp"
#include "m++.hpp"
#include "Parallel.hpp"
#ifdef COMPLEX
#error undef COMPLEX in src/Compiler.h
#endif
typedef std::vector<std::vector<double>> NonlinearOutput;


void FWIForwardMain();

std::vector<NonlinearOutput> FWIInverseMainDGTSVA();

void FWICreateSeismogramDGTS();
void FWIConv();
void FWICalcSeismogramsFromVTK();
void AFFE();
int createKernels2();
int main(int argc, char **argv) {
  Config::SetConfPath("FWI/conf/");
  Config::SetGeoPath("FWI/conf/geo/");
  Config::SetDataPath("data/");

  Config::SetConfigFileName("m++.conf");
  Mpp::initialize(&argc, argv);
  std::string Model = "FWIForward";
  Config::Get("Model", Model);
  bool testAAO = false;
  Config::Get("testAAO", testAAO);

  if (Model == "FWIInverse_DGTS") {
    std::string FWD = "VADGTS";
    Config::Get("ForwardSolver", FWD);
    std::string ReconstructionType = "Classical";
    Config::Get("ReconstructionType", ReconstructionType);
    if (FWD == "VADGTS") {
      auto Results = FWIInverseMainDGTSVA();
      for(const auto &stage: Results) {
        for (const auto &res: stage) {
          for (double re: res) {
            mout << re << endl;
          }
        }
      }
    }
  } else if (Model == "FWICreateSeismogramDGTS") FWICreateSeismogramDGTS();
  else if (Model == "FWICalcSeismogramsFromVTK") FWICalcSeismogramsFromVTK();
  else if (Model == "AFFE") AFFE();
  else if (Model == "FWIConv") FWIConv();
  else if (Model == "createKernels") createKernels2();
  else Exit("not implemented!");
  return 0;
}


