//
// Created by cr on 30/12/22.
//
#include <vector>
#include "FWITestAllAtOncePML2D.hpp"
#include "Config.hpp"
#include "TestEnvironment.hpp"
#include "FWINonlinearSolvers.hpp"

std::vector<NonlinearOutput> FWIInverseMainDGTSVA();

class FWITestAllAtOncePML2D : public Test {
public:
  FWITestAllAtOncePML2D() {
    Config::Initialize(TestFWIAllAtOncePML2DConfigMap);
  }

  void TearDown() override {
    Config::Close();
  }
};

TEST_F(FWITestAllAtOncePML2D, FWITestAllAtOncePML2D) {
  auto NLoutput = FWIInverseMainDGTSVA();
  std::vector<double> output =NLoutput[0][1];
  std::vector<double> input;
input = {403.153683024301,
         46.3343676552514,
         37.4977309328511};
mout << output << endl;
for (int i = 0; i < input.size(); i++) {
input[i] -= output[i];
input[i] *= 1.0 / output[i];
}
EXPECT_VECTOR_NEAR(input, std::vector<double>(input.size(), 0.0), 1e-10);
}

int main(int argc, char **argv) {
  return MppTest(
      MppTestBuilder(argc, argv).
          WithoutDefaultConfig().
          WithScreenLogging().
          WithConfPath("../").
          WithGeoPath("../conf/geo/").
          WithPlotPath("data/vtu/").
          WithPPM()
  ).RUN_ALL_MPP_TESTS();
}