//
// Created by cr on 14.07.21.
//

#include "FWITestReduced1D.hpp"
#include "TestEnvironment.hpp"
#include "FWINonlinearSolvers.hpp"

std::vector<NonlinearOutput> FWIInverseMainDGTSVA();

class FWITestReduced1D : public Test {
public:
    FWITestReduced1D() {
        Config::Initialize(TestFWIReduced1DConfigMap);
    }

    void TearDown() override {
        Config::Close();
    }
};

TEST_F(FWITestReduced1D, TestFWIInverseMainDGTSVA) {
  vector<NonlinearOutput> NLoutput = FWIInverseMainDGTSVA();
  mout << "The residuals are:" << endl;
//  for (int shot = 0; shot< CurrentOutput.size(); ++shot) {
//    mout << "Residuals of shot " + to_string(shot) << endl;
//    for (const auto &Result: CurrentOutput[shot]) {
//      mout << Result << endl;
//    }
//  }
    std::vector<double> output = NLoutput[0][0];
    std::vector<double> input;
    input = {
        0.121880372594341,
        0.116637753713181,
        0.104653232346599,
        0.101750825517248,
        0.0827253595524847,
        0.0797778367653771,
        0.0711126800448138,
        0.0508086645908041,
        0.0394426124905038,
        0.0325498925244508};
    std::cout << endl;
    for (int i = 0; i < input.size(); i++) {
        std::cout << output[i] << endl;
        input[i] -= output[i];
        input[i] *= 1.0 / output[i];
    }
    EXPECT_VECTOR_NEAR(input, std::vector<double>(input.size(), 0.0), 1e-10);
}

int main(int argc, char **argv) {
  return MppTest(
          MppTestBuilder(argc, argv).
                  WithoutDefaultConfig().
                  WithScreenLogging().
                  WithConfPath("../").
                  WithGeoPath("../conf/geo/").
                  WithPlotPath("data/vtu/").
                  WithPPM()
  ).RUN_ALL_MPP_TESTS();
}
