import numpy as np
if __name__ == "__main__":
    import sys
    import argparse
    parser = argparse.ArgumentParser(description='CreateSourceAndReceiverGeometry')
    parser.add_argument("--SrcLoc", type=float,nargs=2)
    parser.add_argument("--ReceiverLength", type=float)
    parser.add_argument("--ReceiverNumber", type=int)
    parser.add_argument("-t0", type=float)
    parser.add_argument("-dt", type=float)
    parser.add_argument("-T", type=float)
    parser.add_argument("--mindist", type=float,default=0.0)
    parser.add_argument("--LayoutStyle", default="Star")
    args = parser.parse_args()
    print(args)
    if args.LayoutStyle == "Star":
        Windrose = ['N','NO','O','SO','S','SW','W','NW']
        for himmelsrichtung in Windrose:
            g = open('Source' + str(args.SrcLoc[0])
                + str(args.SrcLoc[1]) + 'Receiver' + himmelsrichtung + '.txt','w+')
            g.write(str(args.t0) +'\n')
            g.write(str(args.T) +'\n')
            g.write(str(args.dt) +'\n')
            g.write(str(args.ReceiverNumber) + '\n')
            straight = np.linspace(args.mindist,args.ReceiverLength,args.ReceiverNumber)
            for s in straight:
                if himmelsrichtung == 'N':
                    g.write(str(args.SrcLoc[0]) + " " + str(args.SrcLoc[1] + s) + '\n')
                elif himmelsrichtung == 'NO':
                    g.write(str(args.SrcLoc[0]+s/np.sqrt(2))+" " + str(args.SrcLoc[1]+s/np.sqrt(2))+'\n')
                elif himmelsrichtung == 'O':
                    g.write(str(args.SrcLoc[0] + s) + " " + str(args.SrcLoc[1]) + '\n')
                elif himmelsrichtung == 'SO':
                    g.write(str(args.SrcLoc[0]+s/np.sqrt(2))+" " + str(args.SrcLoc[1]-s/np.sqrt(2))+'\n')
                elif himmelsrichtung == 'S':
                    g.write(str(args.SrcLoc[0]) + " " + str(args.SrcLoc[1] - s) + '\n')
                elif himmelsrichtung == 'SW':
                    g.write(str(args.SrcLoc[0]-s/np.sqrt(2)) + " " + str(args.SrcLoc[1] - s/np.sqrt(2)) + '\n')
                elif himmelsrichtung == 'W':
                    g.write(str(args.SrcLoc[0]-s) + " " + str(args.SrcLoc[1]) + '\n')
                elif himmelsrichtung == 'NW':
                    g.write(str(args.SrcLoc[0]-s/np.sqrt(2)) + " " + str(args.SrcLoc[1] + s/np.sqrt(2)) + '\n')
            g.close()
    if args.LayoutStyle == "Net":
        g = open('Source' + str(args.SrcLoc[0])+ str(args.SrcLoc[1]) + 'ReceiverNet.txt', 'w+')
        g.write(str(args.t0) + '\n')
        g.write(str(args.T) + '\n')
        g.write(str(args.dt) + '\n')
        g.write(str(4*args.ReceiverNumber*args.ReceiverNumber) + '\n')
        if args.mindist < 10e-10:
            exit("mindist should not be zero")
        straight = np.linspace(args.mindist, args.ReceiverLength, args.ReceiverNumber)
        straightBackwards= np.linspace(-args.mindist, -args.ReceiverLength, args.ReceiverNumber)
        full = np.hstack((straightBackwards[::-1], straight))
        for y in full:
            for x in full:
                 g.write(str(args.SrcLoc[0]+x) + " " + str(args.SrcLoc[1] + y) + '\n')
        g.close()
